#include "config.h"

#include <unistd.h>
#include <libconfig.h>

config_t config;

int
try_preload_config(const char *filename)
{
    if (access(filename, F_OK) != 0) {
        return CFG_PLD_NOT_FOUND;
    }
    if (config_read_file(&config, filename) == CONFIG_FALSE) {
        return CFG_PLD_INVALID;
    }
    return CFG_PLD_OK;
}

int
preload_config(const char *filename)
{
    char **filename_ptr = config_preload_paths;
    int err;
    if (filename) {
        err = try_preload_config(filename);
        if (err != CFG_PLD_NOT_FOUND) {
            return err;
        }
    }
    while (filename_ptr && (err = try_preload_config(*filename_ptr++))) {
        if (err != CFG_PLD_NOT_FOUND) {
            return err;
        }
    }
}
